Index: branches/PersistenceOverhaul/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs
===================================================================
--- branches/PersistenceOverhaul/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 13368)
+++ branches/PersistenceOverhaul/HeuristicLab.Tests/HeuristicLab.Persistence-3.3/UseCases.cs	(revision 13370)
@@ -639,5 +639,6 @@
         XmlGenerator.Serialize(c, tempFile);
         Assert.Fail("Exception not thrown");
-      } catch (PersistenceException) {
+      }
+      catch (PersistenceException) {
       }
     }
@@ -653,5 +654,6 @@
         XmlGenerator.Serialize(s, tempFile);
         Assert.Fail("Exception expected");
-      } catch (PersistenceException) { }
+      }
+      catch (PersistenceException) { }
       List<int> newList = (List<int>)XmlParser.Deserialize(tempFile);
       Assert.AreEqual(list[0], newList[0]);
@@ -698,5 +700,6 @@
         }
         Assert.Fail("Exception expected");
-      } catch (PersistenceException px) {
+      }
+      catch (PersistenceException px) {
         Assert.AreEqual(3, px.Data.Count);
       }
@@ -728,5 +731,6 @@
         d = new Deserializer(XmlParser.ParseTypeCache(new StringReader(newTypeString)));
         Assert.Fail("Exception expected");
-      } catch (PersistenceException x) {
+      }
+      catch (PersistenceException x) {
         Assert.IsTrue(x.Message.Contains("incompatible"));
       }
@@ -737,5 +741,6 @@
         d = new Deserializer(XmlParser.ParseTypeCache(new StringReader(newTypeString)));
         Assert.Fail("Exception expected");
-      } catch (PersistenceException x) {
+      }
+      catch (PersistenceException x) {
         Assert.IsTrue(x.Message.Contains("newer"));
       }
@@ -922,5 +927,6 @@
         ExplodingDefaultConstructor newX = (ExplodingDefaultConstructor)XmlParser.Deserialize(tempFile);
         Assert.Fail("Exception expected");
-      } catch (PersistenceException pe) {
+      }
+      catch (PersistenceException pe) {
         Assert.AreEqual(pe.InnerException.Message, "this constructor will always fail");
       }
@@ -935,5 +941,6 @@
         XmlGenerator.Serialize(ns, tempFile);
         Assert.Fail("PersistenceException expected");
-      } catch (PersistenceException x) {
+      }
+      catch (PersistenceException x) {
         Assert.IsTrue(x.Message.Contains(new StorableSerializer().JustifyRejection(typeof(NonSerializable))));
       }
@@ -987,5 +994,5 @@
     }
 
-    [StorableClass(StorableClassType.AllFields)]
+    [StorableClass(StorableClassType.AllFields, "B9AB42E8-1932-425B-B4CF-F31F07EAC599")]
     public class AllFieldsStorable {
       public int Value1 = 1;
@@ -1018,5 +1025,5 @@
     }
 
-    [StorableClass(StorableClassType.AllProperties)]
+    [StorableClass(StorableClassType.AllProperties, "CB7DC31C-AEF3-4EB8-91CA-248B767E9F92")]
     public class AllPropertiesStorable {
       public int Value1 = 1;
@@ -1050,5 +1057,5 @@
     }
 
-    [StorableClass(StorableClassType.AllFieldsAndAllProperties)]
+    [StorableClass(StorableClassType.AllFieldsAndAllProperties, "0AD8D68F-E0FF-4FA8-8A72-1148CD91A2B9")]
     public class AllFieldsAndAllPropertiesStorable {
       public int Value1 = 1;
@@ -1081,5 +1088,5 @@
     }
 
-    [StorableClass(StorableClassType.MarkedOnly)]
+    [StorableClass(StorableClassType.MarkedOnly, "0D94E6D4-64E3-4637-B1EE-DEF2B3F6E2E0")]
     public class MarkedOnlyStorable {
       public int Value1 = 1;
@@ -1256,6 +1263,8 @@
         XmlGenerator.Serialize(new ReadOnlyFail(), tempFile);
         Assert.Fail("Exception expected");
-      } catch (PersistenceException) {
-      } catch {
+      }
+      catch (PersistenceException) {
+      }
+      catch {
         Assert.Fail("PersistenceException expected");
       }
@@ -1278,6 +1287,8 @@
         XmlGenerator.Serialize(new WriteOnlyFail(), tempFile);
         Assert.Fail("Exception expected");
-      } catch (PersistenceException) {
-      } catch {
+      }
+      catch (PersistenceException) {
+      }
+      catch {
         Assert.Fail("PersistenceException expected.");
       }
@@ -1461,5 +1472,5 @@
       b[2] = byte.MaxValue;
       XmlGenerator.Serialize(b, tempFile);
-      var newB = (byte[]) XmlParser.Deserialize(tempFile);
+      var newB = (byte[])XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(b, newB);
     }
@@ -1469,7 +1480,7 @@
     [TestProperty("Time", "short")]
     public void TestOptionalNumberEnumerable() {
-      var values = new List<double?> {0, null, double.NaN, double.PositiveInfinity, double.MaxValue, 1};
+      var values = new List<double?> { 0, null, double.NaN, double.PositiveInfinity, double.MaxValue, 1 };
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<double?>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<double?>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1482,5 +1493,5 @@
         DateTime.ParseExact("10.09.2014 12:21", "dd.MM.yyyy hh:mm", CultureInfo.InvariantCulture), DateTime.MaxValue};
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<DateTime?>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<DateTime?>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1490,7 +1501,7 @@
     [TestProperty("Time", "short")]
     public void TestStringEnumerable() {
-      var values = new List<string> {"", null, "s", "string", string.Empty, "123", "<![CDATA[nice]]>", "<![CDATA[nasty unterminated"};
+      var values = new List<string> { "", null, "s", "string", string.Empty, "123", "<![CDATA[nice]]>", "<![CDATA[nasty unterminated" };
       XmlGenerator.Serialize(values, tempFile);
-      var newValues = (List<String>) XmlParser.Deserialize(tempFile);
+      var newValues = (List<String>)XmlParser.Deserialize(tempFile);
       CollectionAssert.AreEqual(values, newValues);
     }
@@ -1500,5 +1511,5 @@
     [TestProperty("Time", "short")]
     public void TestUnicodeCharArray() {
-      var s = Encoding.UTF8.GetChars(new byte[] {0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb});
+      var s = Encoding.UTF8.GetChars(new byte[] { 0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb });
       XmlGenerator.Serialize(s, tempFile);
       var newS = (char[])XmlParser.Deserialize(tempFile);
@@ -1510,5 +1521,5 @@
     [TestProperty("Time", "short")]
     public void TestUnicode() {
-      var s = Encoding.UTF8.GetString(new byte[] {0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb});
+      var s = Encoding.UTF8.GetString(new byte[] { 0, 1, 2, 03, 04, 05, 06, 07, 08, 09, 0xa, 0xb });
       XmlGenerator.Serialize(s, tempFile);
       var newS = XmlParser.Deserialize(tempFile);
@@ -1520,5 +1531,5 @@
     [TestProperty("Time", "short")]
     public void TestQueue() {
-      var q = new Queue<int>(new[] {1, 2, 3, 4, 0});
+      var q = new Queue<int>(new[] { 1, 2, 3, 4, 0 });
       XmlGenerator.Serialize(q, tempFile);
       var newQ = (Queue<int>)XmlParser.Deserialize(tempFile);